# telephone - version pour les etudiants

from Tkinter import *
import string


class Telephone:
    """representation graphique d'un telephone:
    - appareil : fenetre graphique
    - ecran : champ d'affichage
    - clavier : champ de clavier
    - touches : liste des boutons
    - zone_texte : zone d'affichage du texte
    - texte : liste des debuts possibles
    """
    def __init__(self):
        self.appareil()
    
    def appareil(self, width=150, height=300):
        self.appareil = Tk()
        self.ecran = Canvas(self.appareil, width=width, height=height/2)
        self.ecran.grid(row=0)
        self.clavier = Canvas(self.appareil, width=width, height=height/2, background='yellow')
        self.clavier.grid(row=1)
        self.installe_touches()
        self.zone_texte = Label(self.ecran)
        self.zone_texte.grid()
        self.texte = []
    
    def installe_touches(self):
        self.touches = [Touche(i, self) for i in range(10)]


    def complete_mot(self, lettres):
    # a completer
        self.zone_texte.configure(text='mot')

class Touche:
    """representation et positionnement d'une touche:
    - numero
    - lettres : lettres associees (chaine de caracteres)
    - touche : objet graphique
    """
    def __init__(self, i, telephone):
        self.numero = i
        lettres = (' ', '.,?', 'abc', 'def', 'ghi',
                   'jkl', 'mno', 'pqrs', 'tuv', 'wxyz')
        self.lettres = lettres[i]
        self.touche = Button(telephone.clavier, width='10',
                             text=' '.join((str(i), lettres[i])),
                             command=lambda l=self.lettres:
                             telephone.complete_mot(l))
        if i==0:
            self.touche.grid(row=3, column=1)
        else:
            self.touche.grid(row=((i-1)/3), column=(i-1)%3)
            

if __name__ == "__main__":
    t = Telephone()
    t.appareil.mainloop()
